/*
 File: subrule_vectorsym.cpp
 Date and Time: Fri Jan 30 18:55:24 2015 
*/
#include "subrule_vector.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_subrule_vector;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_subrule_vector::TH_subrule_vector(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_subrule_vector;
  NS_subrule_vector::Csubrule_vector Csubrule_vector_;// parallel-parser's parse table
#define ssPARSE_TABLE Csubrule_vector_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_subrule_vector::PROC_TH_subrule_vector(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_subrule_vector";
  static bool one_time(false);
  static NS_subrule_vector::Csubrule_vector* NS_subrule_vector_Csubrule_vector_(0);// parallel-parser's fsm table
  static Parser* NS_subrule_vector_Csubrule_vector_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_subrule_vector_Csubrule_vector_ = new NS_subrule_vector::Csubrule_vector();// parallel-parser's fsm table
    NS_subrule_vector_Csubrule_vector_parser = new Parser(*NS_subrule_vector_Csubrule_vector_,Caller_pp);
  }
 proc_parser = NS_subrule_vector_Csubrule_vector_parser;
#include "wproc_pp_core.h"
}
void 
Csubrule_vector::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rsubrule_vector_:{
       Rsubrule_vector* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_vector(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_vector*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     sym->op();
     return;}
    default: return;
   }
}
